;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

              #include <P16F628A.INC>
              LIST        p=16F628A     
              __CONFIG    H'3F18'           ; 
                                               
              errorlevel  -302              ;     302  

Sec           equ         0020h             ;  
Sec1          equ         0021h             ;
Sec2          equ         0022h             ;
nomer         equ         0023h             ;   ascii 
scetbit       equ         0024h             ;  -   
perem         equ         0025h             ;     spi               
temp          equ         0026h             ;  
tmp_tab       equ         0027h             ;   
x_adr         equ         0028h             ;      X
y_adr         equ         0029h             ;      Y

flag          equ         007Fh             ; 
              
#DEFINE       res_lcd     PORTB,0           ;   -
#DEFINE       cs          PORTB,1           ;   LCD  Nokia 5110
#DEFINE       dat_com     PORTB,2           ;
#DEFINE       sdata       PORTB,3           ;
#DEFINE       sclk        PORTB,4           ;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

              org         0000h             ;     0000h
              goto        Start             ;   Start
           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
                                             
Start         movlw       b'00010011'       ;     B     
              movwf       PORTB             ; 
              
              movlw       b'00000111'       ; 
              movwf       CMCON             ;

              bsf         STATUS,RP0        ; 1-     
              movlw       b'11100000'       ;  \  B      
              movwf       TRISB             ;RB0,RB1 -  ,                      
              bcf         STATUS,RP0        ; 0-  
                           
              call        init_lcd          ;   
              call        clear_lcd         ;   

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

              movlw       '+'               ;  ( PIC16)
              call        viv_symb          ;
              movlw       'P'               ;
              call        viv_symb          ;
              movlw       'I'               ;
              call        viv_symb          ;
              movlw       'C'               ;
              call        viv_symb          ;
              movlw       '1'               ;
              call        viv_symb          ;
              movlw       '6'               ;
              call        viv_symb          ;
              movlw       '+'               ;
              call        viv_symb          ;
              call        paus1s            ; 1 

              call        ust_cur_3         ;    4- 
              movlw       ' '               ;  ( NOKIA)
              call        viv_symb          ;
              movlw       'N'               ;
              call        viv_symb          ;
              movlw       'O'               ;
              call        viv_symb          ;
              movlw       'K'               ;
              call        viv_symb          ;
              movlw       'I'               ;
              call        viv_symb          ;
              movlw       'A'               ;
              call        viv_symb          ;
              call        paus1s            ; 1 

              call        ust_cur_5         ;    5- 
              movlw       ' '               ;  (  5110)
              call        viv_symb          ;
              movlw       ' '               ;
              call        viv_symb          ;
              movlw       '5'               ;
              call        viv_symb          ;
              movlw       '1'               ;
              call        viv_symb          ;
              movlw       '1'               ;
              call        viv_symb          ;
              movlw       '0'               ;
              call        viv_symb          ;
           
met_1         nop                           ; 
              goto        met_1             ;
                   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

init_lcd      bcf        res_lcd            ;            
              movlw      .200               ; .0   RST:   
              movwf      scetbit            ; 0,6 
in_1          decfsz     scetbit,F          ;
              goto       in_1               ; 
              bsf        res_lcd            ;          
                          
              movlw      0x21               ;  , .,   
              call       sendispcom         ;
              movlw      0x13               ;   Bias 1:48
              call       sendispcom         ;
              movlw      0x04               ;   0
              call       sendispcom         ;
              movlw      0xC1               ;  ( 0x65)
              call       sendispcom         ;
              movlw      0x20               ;  
              call       sendispcom         ;
              movlw      0x0C               ; -   
              call       sendispcom         ;
              return                        ;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ust_cur_1     movlw       0x40              ;    Y0
              movwf       y_adr
              call        sendispcom
              goto        ust
ust_cur_2     movlw       0x41              ;    Y1
              movwf       y_adr
              call        sendispcom
              goto        ust
ust_cur_3     movlw       0x42              ;    Y2
              movwf       y_adr
              call        sendispcom
              goto        ust
ust_cur_4     movlw       0x43              ;    Y3
              movwf       y_adr
              call        sendispcom
              goto        ust
ust_cur_5     movlw       0x44              ;    Y4
              movwf       y_adr
              call        sendispcom
              goto        ust
ust_cur_6     movlw       0x45              ;    Y5
              movwf       y_adr
              call        sendispcom
ust           movlw       0x80              ;    X0
              movwf       x_adr
              call        sendispcom
              return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

clear_lcd     movlw      0x40               ;  
              movwf      y_adr
              call       sendispcom         ;    Y0
              movlw      0x80   
              movwf      x_adr           
              call       sendispcom         ;    X0
              movlw      .6                 ; ,  504
              movwf      Sec1
povt4         movlw      .84
              movwf      Sec
povt3         movlw      .0
              call       sendispdat         ;  0x00  
              decfsz     Sec,F              ;  504 
              goto       povt3              ;  
              decfsz     Sec1,F             
              goto       povt4
              return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

sendispcom    movwf      perem              ;  /  
              bcf        dat_com
              goto       povt1
sendispdat    movwf      perem
              bsf        dat_com
povt1         movlw      .8
              movwf      scetbit
              bcf        cs
povt2         bcf        sclk
              btfsc      perem,7
              bsf        sdata
              btfss      perem,7
              bcf        sdata
              bsf        sclk                                   
              rlf        perem,F
              decfsz     scetbit,F             
              goto       povt2
              bsf        cs
              return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
      
viv_symb      movwf       nomer             ;    
              sublw       .47               ;
              btfss       STATUS,C          ;
              goto        viv_symb_1        ;   47:    viv_symb_1
              movlw       .32               ;  nomer      (ASCII  32)
              xorwf       nomer,W           ;
              btfss       STATUS,Z
              goto        viv_s1            ; :   viv_s1
              movlw       .0                ;     (ASCII  32)
              movwf       nomer             ;  .  
              goto        viv_tab4

viv_s1        movlw       .43               ;  nomer     '+' (ASCII  43)
              xorwf       nomer,W           ;
              btfss       STATUS,Z
              goto        viv_s2            ; :   viv_s1
              movlw       .1                ;    '+' (ASCII  43)
              movwf       nomer             ;  .  
              goto        viv_tab4           

viv_s2        movlw       .45               ;  nomer     '-' (ASCII  45)
              xorwf       nomer,W           ;
              btfss       STATUS,Z
              goto        viv_s3            ; :   viv_s1
              movlw       .2                ;    '-' (ASCII  45)
              movwf       nomer             ;  .  
              goto        viv_tab4

viv_s3        movlw       .46               ;  nomer     '.' (ASCII  46)
              xorwf       nomer,W           ;
              btfss       STATUS,Z
              return                        ; :   
              movlw       .3                ;    '.' (ASCII  46)
              movwf       nomer             ;  .  
              goto        viv_tab4

viv_symb_1    movf        nomer,W
              sublw       .57
              btfss       STATUS,C
              goto        viv_symb_2        ;   57:    viv_symb_2
              movlw       .48               ;   47   58:    tab_symb_1
              subwf       nomer,F           ;  48  ASCII  , 
              movlw       .1                ;  
              movwf       tmp_tab           ;   (1)   tmp_tab
              goto        symb_lcd

viv_symb_2    movf        nomer,W
              sublw       .64
              btfsc       STATUS,C
              return                        ;   57   65:   

              movf        nomer,W
              sublw       .78
              btfss       STATUS,C
              goto        viv_symb_3        ;   78:    viv_symb_3
              movlw       .65               ;   64   79:    tab_symb_2
              subwf       nomer,F           ;  65  ASCII  ,  
              movlw       .2                ;  
              movwf       tmp_tab           ;   (2)   tmp_tab
              goto        symb_lcd

viv_symb_3    movf        nomer,W
              sublw       .90
              btfss       STATUS,C
              goto        viv_symb_4        ;   90:    viv_symb_4
              movlw       .79               ;   78   91:    tab_symb_3
              subwf       nomer,F           ;  79  ASCII  ,  
              movlw       .3                ;  
              movwf       tmp_tab           ;   (3)   tmp_tab
              goto        symb_lcd

viv_symb_4    movlw       .176              ;  nomer     176
              xorwf       nomer,W           ;176 - ascii    , 
              btfss       STATUS,Z
              return                        ;  :   
              movlw       .4                ;   176,   , 
              movwf       nomer             ;  .  
viv_tab4      movlw       .4
              movwf       tmp_tab           ;   (4)   tmp_tab

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

symb_lcd      movlw      .17                 ;     18
              movwf      temp
              movf       nomer,W
symb_1        addwf      nomer,F
              decfsz     temp,F
              goto       symb_1
              bcf        flag,0
     
symb_2        movlw      .9 
              movwf      temp               ;    9  

symb_3        movlw       .1                ;    
              xorwf       tmp_tab,W         ;   
              btfss       STATUS,Z
              goto        symb_m1
              call        tab_symb_1
              goto        symb_4
symb_m1       movlw       .2
              xorwf       tmp_tab,W
              btfss       STATUS,Z
              goto        symb_m2
              call        tab_symb_2
              goto        symb_4   
symb_m2       movlw       .3
              xorwf       tmp_tab,W
              btfss       STATUS,Z
              goto        symb_m3
              call        tab_symb_3
              goto        symb_4  
symb_m3       call        tab_symb_4

symb_4        call       sendispdat          ;    
              incf       nomer,F
              incf       x_adr,F
              decfsz     temp,F
              goto       symb_3

              movlw      .0
              call       sendispdat          ;   (0x00)  
              incf       x_adr,F

              btfsc      flag,0
              goto       viv_4
         
              movlw      .10
              subwf      x_adr,F
              incf       y_adr,F
              movf       y_adr,W             ;    Y+1
              call       sendispcom 
              movf       x_adr,W             ;    X-10
              call       sendispcom 
              bsf        flag,0
              goto       symb_2

viv_4         decf       y_adr,F
              movf       y_adr,W          ;    Y-1
              call       sendispcom 
              return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

tab_symb_1    movlw       high tab1         ;    
              movwf       PCLATH            ; 0-9
              movf        nomer,W           ;
              addlw       low tab1          ;
              btfsc       STATUS,C          ;
              incf        PCLATH,F          ;
              movf        nomer,W           ;
              addwf       PCL,F  
                                                  
tab1          dt 0xfc,0xfe,0x03,0x83,0xc3,0x63,0x33,0xfe,0xfc; 
              dt 0x0f,0x1f,0x33,0x31,0x30,0x30,0x30,0x1f,0x0f; '0'    ASCII  48
              dt 0x00,0x10,0x18,0x1c,0xfe,0xff,0x00,0x00,0x00; 
              dt 0x00,0x30,0x30,0x30,0x3f,0x3f,0x30,0x30,0x30; '1'
              dt 0x0c,0x0e,0x03,0x03,0x03,0x83,0xc3,0x7e,0x3c; 
              dt 0x30,0x38,0x3c,0x36,0x33,0x31,0x30,0x30,0x30; '2'
              dt 0x0c,0x0e,0x03,0xc3,0xc3,0xc3,0xc3,0xfe,0x3c; 
              dt 0x0c,0x1c,0x30,0x30,0x30,0x30,0x30,0x1f,0x0f; '3'
              dt 0xc0,0xe0,0xb0,0x98,0x8c,0x86,0x83,0xff,0xff; 
              dt 0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x3f,0x3f; '4'
              dt 0x3f,0x7f,0x63,0x63,0x63,0x63,0x63,0xe3,0xc3; 
              dt 0x1c,0x3c,0x30,0x30,0x30,0x30,0x30,0x3f,0x1f; '5'
              dt 0xfe,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0xc7,0x86; 
              dt 0x1f,0x3f,0x30,0x30,0x30,0x30,0x30,0x3f,0x1f; '6'
              dt 0x00,0x03,0x03,0x03,0x03,0x83,0xc3,0x7f,0x3f; 
              dt 0x00,0x00,0x00,0x3e,0x3f,0x01,0x00,0x00,0x00; '7'
              dt 0xbe,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0xff,0xbe; 
              dt 0x1f,0x3f,0x30,0x30,0x30,0x30,0x30,0x3f,0x1f; '8'
              dt 0x7e,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0xff,0xfe; 
              dt 0x18,0x38,0x30,0x30,0x30,0x30,0x30,0x3f,0x1f; '9'   ASCII  57

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

tab_symb_2    movlw       high tab2         ;    
              movwf       PCLATH            ;  A-N
              movf        nomer,W           ;
              addlw       low tab2          ;
              btfsc       STATUS,C          ;
              incf        PCLATH,F          ;
              movf        nomer,W           ;
              addwf       PCL,F  

tab2          dt 0xfc,0xfe,0xc3,0xc3,0xc3,0xc3,0xc3,0xfe,0xfc; 
              dt 0x3f,0x3f,0x00,0x00,0x00,0x00,0x00,0x3f,0x3f; 'A'    ASCII  65
              dt 0xff,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0x3c,0x3c; 
              dt 0x3f,0x3f,0x30,0x30,0x30,0x30,0x30,0x0f,0x0f; 'B'
              dt 0xfc,0xfc,0x03,0x03,0x03,0x03,0x03,0x0c,0x0c; 
              dt 0x0f,0x0f,0x30,0x30,0x30,0x30,0x30,0x0c,0x0c; 'C'
              dt 0xff,0xff,0x03,0x03,0x03,0x03,0x03,0xfc,0xfc; 
              dt 0x3f,0x3f,0x30,0x30,0x30,0x30,0x30,0x0f,0x0f; 'D'
              dt 0xff,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0xc3,0x03; 
              dt 0x3f,0x3f,0x30,0x30,0x30,0x30,0x30,0x30,0x30; 'E'
              dt 0xff,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0xc3,0x03; 
              dt 0x3f,0x3f,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 'F'
              dt 0xfc,0xfe,0x03,0x03,0x83,0x83,0x83,0x8e,0x8c; 
              dt 0x0f,0x1f,0x30,0x30,0x31,0x31,0x31,0x1f,0x0f; 'G'
              dt 0xff,0xff,0xc0,0xc0,0xc0,0xc0,0xc0,0xff,0xff; 
              dt 0x3f,0x3f,0x00,0x00,0x00,0x00,0x00,0x3f,0x3f; 'H'
              dt 0x00,0x03,0x03,0xff,0xff,0x03,0x03,0x00,0x00; 
              dt 0x00,0x30,0x30,0x3f,0x3f,0x30,0x30,0x00,0x00; 'I'
              dt 0x00,0x00,0x00,0x03,0x03,0xff,0xff,0x03,0x03; 
              dt 0x0c,0x1c,0x30,0x30,0x30,0x1f,0x0f,0x00,0x00; 'J'
              dt 0xff,0xff,0xc0,0xe0,0x30,0x18,0x0c,0x07,0x03; 
              dt 0x3f,0x3f,0x00,0x01,0x03,0x06,0x0c,0x38,0x30; 'K'
              dt 0xff,0xff,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 
              dt 0x3f,0x3f,0x30,0x30,0x30,0x30,0x30,0x30,0x30; 'L'
              dt 0xff,0xff,0x06,0x0c,0x18,0x0c,0x06,0xff,0xff; 
              dt 0x3f,0x3f,0x00,0x00,0x00,0x00,0x00,0x3f,0x3f; 'M'
              dt 0xff,0xff,0x30,0x60,0xc0,0x80,0x00,0xff,0xff; 
              dt 0x3f,0x3f,0x00,0x00,0x00,0x01,0x03,0x3f,0x3f; 'N'   ASCII  78

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

tab_symb_3    movlw       high tab3         ;    
              movwf       PCLATH            ;  O-Z
              movf        nomer,W           ;
              addlw       low tab3          ;
              btfsc       STATUS,C          ;
              incf        PCLATH,F          ;
              movf        nomer,W           ;
              addwf       PCL,F  

tab3          dt 0xfc,0xfe,0x03,0x03,0x03,0x03,0x03,0xfe,0xfc; 
              dt 0x0f,0x1f,0x30,0x30,0x30,0x30,0x30,0x1f,0x0f; 'O'    ASCII  79
              dt 0xff,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0x7e,0x3c; 
              dt 0x3f,0x3f,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 'P'
              dt 0xfc,0xfe,0x03,0x03,0x03,0x03,0x03,0xfe,0xfc; 
              dt 0x0f,0x1f,0x30,0x30,0x34,0x2c,0x18,0x37,0x2f; 'Q'
              dt 0xff,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0x7e,0x3c; 
              dt 0x3f,0x3f,0x01,0x03,0x06,0x0c,0x18,0x30,0x20; 'R'
              dt 0x3c,0x7e,0xc3,0xc3,0xc3,0xc3,0xc3,0x83,0x00; 
              dt 0x00,0x30,0x30,0x30,0x30,0x30,0x30,0x1f,0x0f; 'S'
              dt 0x03,0x03,0x03,0xff,0xff,0xff,0x03,0x03,0x03; 
              dt 0x00,0x00,0x00,0x3f,0x3f,0x3f,0x00,0x00,0x00; 'T'
              dt 0xff,0xff,0x00,0x00,0x00,0x00,0x00,0xff,0xff; 
              dt 0x0f,0x1f,0x30,0x30,0x30,0x30,0x30,0x1f,0x0f; 'U'
              dt 0xff,0xff,0x00,0x00,0x00,0x00,0x00,0xff,0xff; 
              dt 0x03,0x07,0x0c,0x18,0x30,0x18,0x0c,0x07,0x03; 'V'
              dt 0xff,0xff,0x00,0x00,0xff,0x00,0x00,0xff,0xff; 
              dt 0x0f,0x1f,0x30,0x30,0x1f,0x30,0x30,0x1f,0x0f; 'W'
              dt 0x07,0x0f,0x18,0xf0,0xe0,0xf0,0x18,0x0f,0x07; 
              dt 0x38,0x3c,0x06,0x03,0x01,0x03,0x06,0x3c,0x38; 'X'
              dt 0x3f,0x7f,0xc0,0xc0,0xc0,0xc0,0xc0,0x7f,0x3f; 
              dt 0x00,0x00,0x00,0x3f,0x3f,0x3f,0x00,0x00,0x00; 'Y'
              dt 0x03,0x03,0x03,0x83,0xc3,0x63,0x33,0x1f,0x0f; 
              dt 0x3c,0x3e,0x33,0x31,0x30,0x30,0x30,0x30,0x30; 'Z'    ASCII  90

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

tab_symb_4    movlw       high tab4         ;    
              movwf       PCLATH            ;: , , ,  
              movf        nomer,W           ; , 
              addlw       low tab4          ;
              btfsc       STATUS,C          ;
              incf        PCLATH,F          ;
              movf        nomer,W           ;
              addwf       PCL,F  

tab4          dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 
              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; ()  ASCII  32
              dt 0xc0,0xc0,0xc0,0xf8,0xf8,0xc0,0xc0,0xc0,0x00; 
              dt 0x00,0x00,0x00,0x07,0x07,0x00,0x00,0x00,0x00; '+'  ASCII  43
              dt 0x00,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0xc0,0x00; 
              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; '-'  ASCII  45
              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; 
              dt 0x00,0x00,0x00,0x3c,0x3c,0x3c,0x00,0x00,0x00; '.'  ASCII  46
              dt 0x00,0x1c,0x3e,0x63,0x63,0x63,0x3e,0x1c,0x00; 
              dt 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00; (  , ) ASCII  176
              
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

paus1s        movlw       .5                ;  1 
              movwf       Sec2
ps_3          movlw       .255              ;
              movwf       Sec1              ;
ps_2          movlw       .255              ;
              movwf       Sec               ;
ps_1          decfsz      Sec,F             ;
              goto        ps_1              ;
              decfsz      Sec1,F            ;
              goto        ps_2              ;
              decfsz      Sec2,F            ;
              goto        ps_3 
              return                        ;  

              end                           ;  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;